//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once
#ifndef _ACTIVESCRIPTSITE_H_
#define _ACTIVESCRIPTSITE_H_
#include <activscp.h>

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
template <typename T> class ATL_NO_VTABLE IActiveScriptSiteImpl : public IActiveScriptSite
{
	STDMETHOD(GetLCID)(/* [out] */ LCID __RPC_FAR *plcid){	return E_NOTIMPL; }

	STDMETHOD(GetItemInfo)( 
	/* [in] */ LPCOLESTR pstrName,
	/* [in] */ DWORD dwReturnMask,
	/* [out] */ IUnknown **ppiunkItem,
	/* [out] */ ITypeInfo **ppti)
	{
		T* pT = (T*) this;
		return pT->IActiveScriptSite_GetItemInfo(pstrName,dwReturnMask,ppiunkItem,ppti);
	}

	STDMETHOD(GetDocVersionString)(/* [out] */ BSTR __RPC_FAR *pbstrVersion) {	return E_NOTIMPL; }
	
	STDMETHOD(OnScriptTerminate)(/* [in] */ const VARIANT *pvarResult,/* [in] */ const EXCEPINFO *pexcepinfo)
	{
		if(!pexcepinfo){ return E_POINTER; }
		return S_OK;
	}
	
	STDMETHOD(OnStateChange)(/* [in] */ SCRIPTSTATE ssScriptState) 
	{
		T* pT = (T*) this;
		return pT->IActiveScriptSite_OnStateChange(ssScriptState);
	}
	
	STDMETHOD(OnScriptError)(/* [in] */ IActiveScriptError *pscripterror)
	{
		if(!pscripterror){ return E_POINTER; }

		T* pT = (T*) this;
		return pT->IActiveScriptSite_OnScriptError(pscripterror);
	}

	STDMETHOD(OnEnterScript)(void){ return S_OK; }
	
	STDMETHOD(OnLeaveScript)(void){ return S_OK; }

};
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
template <typename T> class ATL_NO_VTABLE IActiveScriptSiteWindowImpl : public IActiveScriptSiteWindow
{
	STDMETHOD(GetWindow)(/* [out] */ HWND *phwnd)
	{
		if(!phwnd) { return E_POINTER; }

		T* pT = (T*) this;
		*phwnd = pT->m_hWnd;
		return S_OK;
	}

    STDMETHOD(EnableModeless)(/* [in] */ BOOL fEnable){ return S_OK; }
};

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#endif