//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once
#ifndef _READER_H_
#define _READER_H_

#include <vector>
#include <string>
using namespace std;

//----------------------------------------------------------------------------------------------------------------------
//Quick n' Dirty design & impl of PropertyBag Reader
//
//
//----------------------------------------------------------------------------------------------------------------------

struct NameValue
{
	std::string strName;
	CComVariant varValue;
};

struct PropertyObjBase
{
	PropertyObjBase():m_clsid(CLSID_NULL),m_bIfSubProp(false){}
	vector<NameValue>					m_map_Name_Val;
	CLSID								m_clsid;		//CLSID of control or sub object
	std::string							m_strObjName;	//either the progid of the control or the sub object name
	bool								m_bIfSubProp;	//is sub object ?

};
typedef std::vector<NameValue>::iterator itNameValue;

struct SubPropBag : public PropertyObjBase{};//TODO: Add the sub object's nested props(MS DB list)
struct MainPropertyBag : public PropertyObjBase
{
	std::vector<SubPropBag>	 m_SubObject;
};


class CReader
{
public:
	CReader(){}
	
	~CReader(){}
	HRESULT OpenFile(LPCTSTR pszFileName);
	
	HRESULT StoreObject(PropertyObjBase *pBag, std::string str,CLSID* pCLSID, string &strObj,bool isSubObject = false);
	HRESULT StoreProperty(PropertyObjBase *pBag, std::string str);
	HRESULT LoopAndStoreProperty(std::vector<string>::iterator &it, MainPropertyBag *pBag);
	HRESULT LoopAndStoreProperty(std::vector<string>::iterator &it, SubPropBag *pBag, MainPropertyBag *pMainBag);

public:
	std::vector<MainPropertyBag>	m_VecBag;
	struct ReaderControlInfo
	{
		ReaderControlInfo() :m_pCLSID(0) {}
		
		~ReaderControlInfo()
		{
			if(m_pCLSID)
			{
				::CoTaskMemFree(m_pCLSID);
				m_pCLSID = 0;
			}
		}
		UINT									m_nControls;
		CLSID									*m_pCLSID;
	}m_ReaderInfo;
};

typedef std::vector<string>::iterator itString;

#endif