//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef _TOOLWINDOW_H_
#define _TOOLWINDOW_H_

#include "resource.h"
#include "Base_Include\Context.H"
//--------------------------------------------------------------------------------------------------------------------

class CContainerFrame;
#include "Base_Include\ATLControls.H"
using namespace ATLControls;

#include <list>

//--------------------------------------------------------------------------------------------------------------------

class CControlToolBox : public CWindowImpl<CControlToolBox, CWindow,CWinTraits<WS_POPUP|WS_VISIBLE|WS_CLIPSIBLINGS|WS_BORDER|WS_DLGFRAME|WS_SYSMENU |WS_THICKFRAME|WS_OVERLAPPED,WS_EX_LEFT|WS_EX_LTRREADING|WS_EX_RIGHTSCROLLBAR|WS_EX_TOOLWINDOW|WS_EX_WINDOWEDGE > >
{
public:
	DECLARE_WND_CLASS_EX(NULL, 0, 0)

	BEGIN_MSG_MAP(CControlToolBox)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRBtnDown)

		NOTIFY_CODE_HANDLER(TTN_NEEDTEXT, OnRelayToolTip)
		
		COMMAND_RANGE_HANDLER(100,200,OnPickDrag)
		COMMAND_ID_HANDLER(ID_CONTROLDIALOG,OnMenuClick)

	ALT_MSG_MAP(1)
		MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRBtnDown)
	END_MSG_MAP()

public:
	CControlToolBox();
	~CControlToolBox();

	void Init(CContainerFrame *pFrame)
	{
		m_pFrame = pFrame;
	}

public:

	LRESULT OnPickDrag(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnMenuClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	LRESULT OnRBtnDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	
	
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnRelayToolTip(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	
	void	LoadToolBoxBmp(LPOLESTR pszclsid);

private:
	struct BtnInfo
	{
		WORD		m_wID;
		CComBSTR	m_bstrCLSID;
	};

	CContainedWindowT<CToolBarCtrl, CWinTraitsOR < WS_CLIPSIBLINGS|TBSTYLE_TOOLTIPS|TBSTYLE_FLAT|TBSTYLE_WRAPABLE|CCS_NODIVIDER|CCS_NOPARENTALIGN|CCS_NORESIZE,0> > m_wndToolBox;
	CContainerFrame							*m_pFrame;
	static	UINT							m_snBtnCount;	
	std::list<BtnInfo>						m_listBtnInfo;
	HFONT									m_hFont;
	
	typedef std::list <BtnInfo>:: iterator itBtnInfo;		
};



//--------------------------------------------------------------------------------------------------------------------

#endif